stages:
  - validate
  - release
  - renovate_bot

include:
  - local: .gitlab-ci-asdf-versions.yml
  - local: .gitlab-ci-other-versions.yml

  # This template should be included in all Infrastructure projects.
  # It includes standard checks, gitlab-scanners, validations and release processes
  # common to all projects using this template library.
  # see https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/README.md#templatesstandardyml
  - project: 'gitlab-com/gl-infra/common-ci-tasks'
    ref: v2.57.0  # renovate:managed
    file: templates/standard.yml

  # Runs golang standard tests, including tests, goreleaser, golangci-lint and go-mod-tidy
  # see https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/templates/golang.md
  - project: 'gitlab-com/gl-infra/common-ci-tasks'
    ref: v2.57.0  # renovate:managed
    file: templates/golang.yml

  # Base template for container builds.
  - project: 'gitlab-com/gl-infra/common-ci-tasks'
    ref: v2.57.0  # renovate:managed
    file: kaniko.yml

  # Analyze commits to determine whether to cut a release
  # see https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/semantic-release.md
  - project: 'gitlab-com/gl-infra/common-ci-tasks'
    ref: v2.57.0  # renovate:managed
    file: semantic-release.yml

📦 Container build:
  stage: release
  needs:
    - 'go_unittests'
  variables:
    KANIKO_DESTINATION: $CI_REGISTRY_IMAGE:${CI_COMMIT_REF_SLUG}
  extends:
    - .kaniko_base
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'

📦 Container build latest:
  stage: release
  variables:
    # Use "latest" when building on the default branch.
    KANIKO_DESTINATION: $CI_REGISTRY_IMAGE:latest
  extends:
    - .kaniko_base
  rules:
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'

📦 Container build tag:
  stage: release
  variables:
    # Tags use the git tag, not the slug
    KANIKO_DESTINATION: $CI_REGISTRY_IMAGE:${CI_COMMIT_TAG}
  extends:
    - .kaniko_base
  rules:
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_TAG != null'
